//
//  ViewController.m
//  TableViewUX
//
//  Created by narita on 2016/08/28.
//  Copyright © 2016年 narita. All rights reserved.
//

#import "ViewController.h"
#import "AppDelegate.h"

@implementation ViewController

#pragma mark -
#pragma mark class methods

#pragma mark -
#pragma mark init methods

#pragma mark -
#pragma mark dealloc

#pragma mark -
#pragma mark NSCopying, hash, isEqual:

#pragma mark -
#pragma mark NSCoding methods

#pragma mark -
#pragma mark awakeFromNib-like methods

#pragma mark -
#pragma mark NSViewController life cycle methods

- (void)viewDidLoad
{
    [super viewDidLoad];
    
    // 表示用モデルデータの作成
    self.recodes = [NSMutableArray array];
    
    for(int i = 0; i < 10; i++)
    {
        [self.recodes addObject:[@{
                                   @"title" : [NSMutableString stringWithFormat:@"String %i", i]
                                   } mutableCopy]];
    }
    
    self.arrayController.content = self.recodes;
}

// TablewViewのboundsのサイズが変わったら、すべてのrawの再計算をする。現在の表示領域と選択rawを保存し、rawの再計算後に、適切に再設定する。
- (void)viewWillLayout
{
    [self.table noteHeightOfRowsWithIndexesChanged:
     [NSIndexSet indexSetWithIndexesInRange:NSMakeRange(0, self.recodes.count)]];
}

#pragma mark -
#pragma mark action methods

#pragma mark -
#pragma mark NSTableViewDelegate methods


- (CGFloat)tableView:(NSTableView *)tv heightOfRow:(NSInteger)row
{
    // Bindingでは"継続してUpdate"のチェックを入れないと即時反映されない
    NSString* theString = [self.recodes[row] valueForKey:@"title"];
    //     ソフト改行を考慮する
    NSSize theSize = NSMakeSize(((NSTableColumn*)[tv.tableColumns firstObject]).width, CGFLOAT_MAX);
    
    // セルのマージンを考慮する
    theSize.width -= tv.intercellSpacing.width;
    
    // 文字列の描画サイズを算出
    NSRect theRect = [theString boundingRectWithSize:theSize
                                             options:NSStringDrawingUsesLineFragmentOrigin
                                          attributes:@{ NSFontAttributeName : [NSFont systemFontOfSize:
                                                                               [NSFont systemFontSize]]}
                                             context:nil];
    
    // セルのマージンを考慮する。
    theRect.size.height -= tv.intercellSpacing.height;
    
    return MAX(theRect.size.height, [tv rowHeight]);
}

#pragma mark -
#pragma mark NSTextFieldDelegate methods

- (void)controlTextDidChange:(NSNotification *)obj
{
    // 1文字入力毎に行の高さの再計算を行う。
    [self.table noteHeightOfRowsWithIndexesChanged:
     [NSIndexSet indexSetWithIndexesInRange:NSMakeRange(self.table.selectedRow, 1)]];
}

- (BOOL)control:(NSControl*)control textView:(NSTextView*)textView doCommandBySelector:(SEL)commandSelector
{
    BOOL theResult = NO;
    
    if (commandSelector == @selector(insertNewline:))
    {
        // 新規作成
        [self.arrayController insertObject:[@{
                                              @"title" : [NSMutableString stringWithFormat:@"String "]
                                              } mutableCopy]
                     atArrangedObjectIndex:self.table.selectedRow + 1];
        
//        [self.table selectRowIndexes:[NSIndexSet indexSetWithIndex:self.table.selectedRow + 1]
//                byExtendingSelection:NO];
//        [self.view.window makeFirstResponder:control];

        theResult = YES;
    }
    
    return theResult;
}

#pragma mark -
#pragma mark accessor methods (in pairs)

#pragma mark -
#pragma mark Utility methods



@end
